diff --git a/web/pgadmin/utils/driver/psycopg3/typecast.py b/web/pgadmin/utils/driver/psycopg3/typecast.py
new file mode 100644
index 000000000..58fefdf19
--- /dev/null
+++ b/web/pgadmin/utils/driver/psycopg3/typecast.py
@@ -0,0 +1,247 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2022, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+"""
+Typecast various data types so that they can be compatible with Javascript
+data types.
+"""
+import psycopg
+from psycopg.types.string import TextLoader
+from psycopg.types.json import JsonDumper, _JsonDumper, _JsonLoader
+from psycopg._encodings import py_codecs as encodings
+from .encoding import get_encoding, configure_driver_encodings
+from psycopg.types.net import InetLoader
+from psycopg.adapt import Loader
+from ipaddress import ip_address, ip_interface
+from psycopg._encodings import py_codecs as encodings
+
+configure_driver_encodings(encodings)
+
+# OIDs of data types which need to typecast as string to avoid JavaScript
+# compatibility issues.
+# e.g JavaScript does not support 64 bit integers. It has 64-bit double
+# giving only 53 bits of integer range (IEEE 754)
+# So to avoid loss of remaining 11 bits (64-53) we need to typecast bigint to
+# string.
+
+TO_STRING_DATATYPES = (
+    # To cast bytea, interval type
+    17, 1186,
+
+    # date, timestamp, timestamp with zone, time without time zone
+    1082, 1114, 1184, 1083
+)
+
+TO_STRING_NUMERIC_DATATYPES = (
+    # Real, double precision, numeric, bigint
+    700, 701, 1700, 20
+)
+
+# OIDs of array data types which need to typecast to array of string.
+# This list may contain:
+# OIDs of data types from PSYCOPG_SUPPORTED_ARRAY_DATATYPES as they need to be
+# typecast to array of string.
+# Also OIDs of data types which psycopg does not typecast array of that
+# data type. e.g: uuid, bit, varbit, etc.
+
+TO_ARRAY_OF_STRING_DATATYPES = (
+    # To cast bytea[] type
+    1001,
+
+    # bigint[]
+    1016,
+
+    # double precision[], real[]
+    1022, 1021,
+
+    # bit[], varbit[]
+    1561, 1563,
+)
+
+# OID of record array data type
+RECORD_ARRAY = (2287,)
+
+# OIDs of builtin array datatypes supported by psycopg
+# OID reference psycopg/psycopg/typecast_builtins.c
+#
+# For these array data types psycopg returns result in list.
+# For all other array data types psycopg returns result as string (string
+# representing array literal)
+# e.g:
+#
+# For below two sql psycopg returns result in different formats.
+#   SELECT '{foo,bar}'::text[];
+#   print('type of {} ==> {}'.format(res[0], type(res[0])))
+#   SELECT '{<a>foo</a>,<b>bar</b>}'::xml[];
+#   print('type of {} ==> {}'.format(res[0], type(res[0])))
+#
+# Output:
+#   type of ['foo', 'bar'] ==> <type 'list'>
+#   type of {<a>foo</a>,<b>bar</b>} ==> <type 'str'>
+
+PSYCOPG_SUPPORTED_BUILTIN_ARRAY_DATATYPES = (
+    1016, 1005, 1006, 1007, 1021, 1022, 1231,
+    1002, 1003, 1009, 1014, 1015, 1009, 1014,
+    1015, 1000, 1115, 1185, 1183, 1270, 1182,
+    1187, 1001, 1028, 1013, 1041, 651, 1040
+)
+
+# json, jsonb
+# OID reference psycopg/lib/_json.py
+PSYCOPG_SUPPORTED_JSON_TYPES = (114, 3802)
+
+# json[], jsonb[]
+PSYCOPG_SUPPORTED_JSON_ARRAY_TYPES = (199, 3807)
+
+ALL_JSON_TYPES = PSYCOPG_SUPPORTED_JSON_TYPES +\
+    PSYCOPG_SUPPORTED_JSON_ARRAY_TYPES
+
+# INET[], CIDR[]
+# OID reference psycopg/lib/_ipaddress.py
+PSYCOPG_SUPPORTED_IPADDRESS_ARRAY_TYPES = (1041, 651)
+
+# uuid[]
+# OID reference psycopg/lib/extras.py
+PSYCOPG_SUPPORTED_IPADDRESS_ARRAY_TYPES = (2951,)
+
+# int4range, int8range, numrange, daterange tsrange, tstzrange[]
+# OID reference psycopg/lib/_range.py
+PSYCOPG_SUPPORTED_RANGE_TYPES = (3904, 3926, 3906, 3912, 3908, 3910)
+
+# int4range[], int8range[], numrange[], daterange[] tsrange[], tstzrange[]
+# OID reference psycopg/lib/_range.py
+PSYCOPG_SUPPORTED_RANGE_ARRAY_TYPES = (3905, 3927, 3907, 3913, 3909, 3911)
+
+
+def register_global_typecasters():
+    # This registers a unicode type caster for datatype 'RECORD'.
+    psycopg.adapters.register_loader(
+        2249, TextLoaderpgAdmin)
+    # This registers a unicode type caster for datatype 'RECORD_ARRAY'.
+    psycopg.adapters.register_loader(
+        2287, TextLoaderpgAdmin)
+
+    for typ in TO_STRING_DATATYPES + TO_STRING_NUMERIC_DATATYPES +\
+            PSYCOPG_SUPPORTED_RANGE_TYPES:
+        psycopg.adapters.register_loader(typ,
+                                         TextLoaderpgAdmin)
+
+    #
+    # # define type caster to convert pg array types of above types into
+    # # array of string type
+    # pg_array_types_to_array_of_string_type = \
+    #     psycopg.extensions.new_array_type(
+    #         TO_ARRAY_OF_STRING_DATATYPES,
+    #         'TYPECAST_TO_ARRAY_OF_STRING', pg_types_to_string_type
+    #     )
+
+    for typ in TO_ARRAY_OF_STRING_DATATYPES:
+        psycopg.adapters.register_loader(typ, TextLoaderpgAdmin)
+
+    psycopg.adapters.register_loader("json",
+                                     TextLoaderpgAdmin)
+    psycopg.adapters.register_loader("jsonb",
+                                     TextLoaderpgAdmin)
+
+    # psycopg.types.json.set_json_loads(loads=lambda x: x)
+
+    class JsonDumperpgAdmin(_JsonDumper):
+
+        def dump(self, obj):
+            return self.dumps(obj).encode()
+
+    psycopg.adapters.register_dumper(dict, JsonDumperpgAdmin)
+
+
+def register_string_typecasters(connection):
+    # raw_unicode_escape used for SQL ASCII will escape the
+    # characters. Here we unescape them using unicode_escape
+    # and send ahead. When insert update is done, the characters
+    # are escaped again and sent to the DB.
+
+    postgres_encoding, python_encoding, typecast_encoding = \
+        get_encoding(connection.info.encoding)
+    if postgres_encoding != 'UTF-8' and postgres_encoding != 'UTF8':
+
+        # class NonAsciiLoader(Loader):
+        #     def load(self, data):
+        #         if data is None:
+        #             return None
+        #         postgres_encoding, python_encoding, typecast_encoding = \
+        #             get_encoding(self.connection.info.encoding)
+        #         return data.decode(python_encoding, errors='replace')
+
+        for typ in (19, 18, 25, 1042, 1043, 0):
+            if connection:
+                connection.adapters.register_loader(typ, TextLoaderpgAdmin)
+        # for typ in (1002, 1003, 1009, 1014, 1015, 0):
+        #     if connection:
+        #         connection.adapters.register_loader(typ,
+        #                                             TextLoaderpgAdmin)
+        # connection.adapters.register_loader(bytes, NonAsciiLoader)
+
+
+def register_binary_typecasters(connection):
+    # The new classes can be registered globally, on a connection, on a cursor
+
+    connection.adapters.register_loader(17,
+                                        pgAdminByteaLoader)
+
+    connection.adapters.register_loader(1001,
+                                        pgAdminByteaLoader)
+
+
+def register_array_to_string_typecasters(connection=None):
+    type_array = PSYCOPG_SUPPORTED_BUILTIN_ARRAY_DATATYPES +\
+        PSYCOPG_SUPPORTED_JSON_ARRAY_TYPES +\
+        PSYCOPG_SUPPORTED_IPADDRESS_ARRAY_TYPES +\
+        PSYCOPG_SUPPORTED_RANGE_ARRAY_TYPES +\
+        TO_ARRAY_OF_STRING_DATATYPES
+
+    for typ in type_array:
+        if connection:
+            connection.adapters.register_loader(typ,
+                                                TextLoaderpgAdmin)
+
+
+class pgAdminInetLoader(InetLoader):
+    def load(self, data):
+        if isinstance(data, memoryview):
+            data = bytes(data)
+
+        if b"/" in data:
+            return str(ip_interface(data.decode()))
+        else:
+            return str(ip_address(data.decode()))
+
+
+# The new classes can be registered globally, on a connection, on a cursor
+psycopg.adapters.register_loader("inet", pgAdminInetLoader)
+
+
+class pgAdminByteaLoader(Loader):
+    def load(self, data):
+        return 'binary data' if data is not None else None
+
+
+class TextLoaderpgAdmin(TextLoader):
+    def load(self, data):
+        if self._encoding:
+            if isinstance(data, memoryview):
+                return bytes(data).decode(self._encoding)
+            else:
+                return data.decode(self._encoding, errors='replace')
+        else:
+            # SQL_ASCII db
+            postgres_encoding, python_encoding, typecast_encoding = \
+                get_encoding(self.connection.info.encoding)
+            try:
+                return data.decode(typecast_encoding)
+            except Exception:
+                return data.decode('UTF-8', errors='replace')
diff --git a/web/pgadmin/utils/driver/registry.py b/web/pgadmin/utils/driver/registry.py
index 1085cac43..6cbcde6d9 100644
--- a/web/pgadmin/utils/driver/registry.py
+++ b/web/pgadmin/utils/driver/registry.py
@@ -15,7 +15,7 @@ from pgadmin.utils.dynamic_registry import create_registry_metaclass
 @classmethod
 def load_modules(cls, app=None):
     submodules = []
-    from . import psycopg2 as module
+    from . import psycopg3 as module
     submodules.append(module)
 
     from . import abstract as module
diff --git a/web/pgadmin/utils/tests/test_encoding.py b/web/pgadmin/utils/tests/test_encoding.py
index 80f6d4eb3..c2aebb4d0 100644
--- a/web/pgadmin/utils/tests/test_encoding.py
+++ b/web/pgadmin/utils/tests/test_encoding.py
@@ -6,7 +6,7 @@
 # This software is released under the PostgreSQL Licence
 #
 ##########################################################################
-from pgadmin.utils.driver.psycopg2.encoding import get_encoding
+from pgadmin.utils.driver.psycopg3.encoding import get_encoding
 from pgadmin.utils.route import BaseTestGenerator
 
 
@@ -15,208 +15,201 @@ class TestEncoding(BaseTestGenerator):
         (
             'When the database encoding is SQL_ASCII',
             dict(
-                db_encoding='SQL_ASCII',
-                expected_return_value=['SQL_ASCII', 'raw_unicode_escape',
-                                       'unicode_escape']
-            )
-        ), (
-            'When the database encoding is MULEINTERNAL',
-            dict(
-                db_encoding='MULEINTERNAL',
-                expected_return_value=['MULEINTERNAL', 'raw_unicode_escape',
-                                       'unicode_escape']
+                db_encoding='raw_unicode_escape',
+                expected_return_value=['SQL_ASCII', 'raw-unicode-escape',
+                                       'unicode-escape']
             )
         ), (
             'When the database encoding is LATIN1',
             dict(
-                db_encoding='LATIN1',
-                expected_return_value=['LATIN1', 'latin1', 'latin1']
+                db_encoding='latin1',
+                expected_return_value=['LATIN1', 'iso8859-1', 'iso8859-1']
             )
         ), (
             'When the database encoding is LATIN2',
             dict(
-                db_encoding='LATIN2',
-                expected_return_value=['LATIN2', 'latin2', 'latin2']
+                db_encoding='latin2',
+                expected_return_value=['LATIN2', 'iso8859-2', 'iso8859-2']
             )
         ), (
             'When the database encoding is LATIN3',
             dict(
-                db_encoding='LATIN3',
-                expected_return_value=['LATIN3', 'latin3', 'latin3']
+                db_encoding='latin3',
+                expected_return_value=['LATIN3', 'iso8859-3', 'iso8859-3']
             )
         ), (
             'When the database encoding is LATIN4',
             dict(
-                db_encoding='LATIN4',
-                expected_return_value=['LATIN4', 'latin4', 'latin4']
+                db_encoding='latin4',
+                expected_return_value=['LATIN4', 'iso8859-4', 'iso8859-4']
             )
         ), (
             'When the database encoding is LATIN5',
             dict(
-                db_encoding='LATIN5',
-                expected_return_value=['LATIN5', 'latin5', 'latin5']
+                db_encoding='latin5',
+                expected_return_value=['LATIN5', 'iso8859-9', 'iso8859-9']
             )
         ), (
             'When the database encoding is LATIN6',
             dict(
-                db_encoding='LATIN6',
-                expected_return_value=['LATIN6', 'latin6', 'latin6']
+                db_encoding='latin6',
+                expected_return_value=['LATIN6', 'iso8859-10', 'iso8859-10']
             )
         ), (
             'When the database encoding is LATIN7',
             dict(
-                db_encoding='LATIN7',
-                expected_return_value=['LATIN7', 'latin7', 'latin7']
+                db_encoding='latin7',
+                expected_return_value=['LATIN7', 'iso8859-13', 'iso8859-13']
             )
         ), (
             'When the database encoding is LATIN8',
             dict(
-                db_encoding='LATIN8',
-                expected_return_value=['LATIN8', 'latin8', 'latin8']
+                db_encoding='latin8',
+                expected_return_value=['LATIN8', 'iso8859-14', 'iso8859-14']
             )
         ), (
             'When the database encoding is LATIN9',
             dict(
-                db_encoding='LATIN9',
-                expected_return_value=['LATIN9', 'latin9', 'latin9']
+                db_encoding='latin9',
+                expected_return_value=['LATIN9', 'iso8859-15', 'iso8859-15']
             )
         ), (
             'When the database encoding is LATIN10',
             dict(
-                db_encoding='LATIN10',
-                expected_return_value=['LATIN10', 'latin10', 'latin10']
+                db_encoding='latin10',
+                expected_return_value=['LATIN10', 'iso8859-16', 'iso8859-16']
             )
         ), (
             'When the database encoding is WIN1250',
             dict(
-                db_encoding='WIN1250',
+                db_encoding='cp1250',
                 expected_return_value=['WIN1250', 'cp1250', 'cp1250']
             )
         ), (
             'When the database encoding is WIN1251',
             dict(
-                db_encoding='WIN1251',
+                db_encoding='cp1251',
                 expected_return_value=['WIN1251', 'cp1251', 'cp1251']
             )
         ), (
             'When the database encoding is WIN1252',
             dict(
-                db_encoding='WIN1252',
+                db_encoding='cp1252',
                 expected_return_value=['WIN1252', 'cp1252', 'cp1252']
             )
         ), (
             'When the database encoding is WIN1253',
             dict(
-                db_encoding='WIN1253',
+                db_encoding='cp1253',
                 expected_return_value=['WIN1253', 'cp1253', 'cp1253']
             )
         ), (
             'When the database encoding is WIN1254',
             dict(
-                db_encoding='WIN1254',
+                db_encoding='cp1254',
                 expected_return_value=['WIN1254', 'cp1254', 'cp1254']
             )
         ), (
             'When the database encoding is WIN1255',
             dict(
-                db_encoding='WIN1255',
+                db_encoding='cp1255',
                 expected_return_value=['WIN1255', 'cp1255', 'cp1255']
             )
         ), (
             'When the database encoding is WIN1256',
             dict(
-                db_encoding='WIN1256',
+                db_encoding='cp1256',
                 expected_return_value=['WIN1256', 'cp1256', 'cp1256']
             )
         ), (
             'When the database encoding is WIN1257',
             dict(
-                db_encoding='WIN1257',
+                db_encoding='cp1257',
                 expected_return_value=['WIN1257', 'cp1257', 'cp1257']
             )
         ), (
             'When the database encoding is WIN1258',
             dict(
-                db_encoding='WIN1258',
+                db_encoding='cp1258',
                 expected_return_value=['WIN1258', 'cp1258', 'cp1258']
             )
         ), (
             'When the database encoding is EUC_JIS_2004',
             dict(
-                db_encoding='EUC_JIS_2004',
-                expected_return_value=['EUC_JIS_2004', 'eucjis2004',
-                                       'eucjis2004']
+                db_encoding='eucjis2004',
+                expected_return_value=['EUC_JIS_2004', 'euc_jis_2004',
+                                       'euc_jis_2004']
             )
         ), (
             'When the database encoding is EUC_CN',
             dict(
-                db_encoding='EUC_CN',
-                expected_return_value=['EUC_CN', 'euc-cn', 'euc-cn']
+                db_encoding='euc-cn',
+                expected_return_value=['EUC_CN', 'gb2312', 'gb2312']
             )
         ), (
             'When the database encoding is EUC_JP',
             dict(
-                db_encoding='EUC_JP',
+                db_encoding='euc_jp',
                 expected_return_value=['EUC_JP', 'euc_jp', 'euc_jp']
             )
         ), (
             'When the database encoding is EUC_KR',
             dict(
-                db_encoding='EUC_KR',
+                db_encoding='euc_kr',
                 expected_return_value=['EUC_KR', 'euc_kr', 'euc_kr']
             )
         ), (
             'When the database encoding is EUC_TW',
             dict(
-                db_encoding='EUC_TW',
+                db_encoding='big5',
                 expected_return_value=['BIG5', 'big5', 'big5']
             )
         ), (
             'When the database encoding is ISO_8859_5',
             dict(
-                db_encoding='ISO_8859_5',
-                expected_return_value=['ISO_8859_5', 'iso8859_5', 'iso8859_5']
+                db_encoding='iso8859_5',
+                expected_return_value=['ISO_8859_5', 'iso8859-5', 'iso8859-5']
             )
         ), (
             'When the database encoding is ISO_8859_6',
             dict(
-                db_encoding='ISO_8859_6',
-                expected_return_value=['ISO_8859_6', 'iso8859_6', 'iso8859_6']
+                db_encoding='iso8859_6',
+                expected_return_value=['ISO_8859_6', 'iso8859-6', 'iso8859-6']
             )
         ), (
             'When the database encoding is ISO_8859_7',
             dict(
-                db_encoding='ISO_8859_7',
-                expected_return_value=['ISO_8859_7', 'iso8859_7', 'iso8859_7']
+                db_encoding='iso8859_7',
+                expected_return_value=['ISO_8859_7', 'iso8859-7', 'iso8859-7']
             )
         ), (
             'When the database encoding is ISO_8859_8',
             dict(
-                db_encoding='ISO_8859_8',
-                expected_return_value=['ISO_8859_8', 'iso8859_8', 'iso8859_8']
+                db_encoding='iso8859_8',
+                expected_return_value=['ISO_8859_8', 'iso8859-8', 'iso8859-8']
             )
         ), (
             'When the database encoding is KOI8R',
             dict(
-                db_encoding='KOI8R',
-                expected_return_value=['KOI8R', 'koi8_r', 'koi8_r']
+                db_encoding='koi8_r',
+                expected_return_value=['KOI8R', 'koi8-r', 'koi8-r']
             )
         ), (
             'When the database encoding is KOI8U',
             dict(
-                db_encoding='KOI8U',
-                expected_return_value=['KOI8U', 'koi8_u', 'koi8_u']
+                db_encoding='koi8_u',
+                expected_return_value=['KOI8U', 'koi8-u', 'koi8-u']
             )
         ), (
             'When the database encoding is WIN866',
             dict(
-                db_encoding='WIN866',
+                db_encoding='cp866',
                 expected_return_value=['WIN866', 'cp866', 'cp866']
             )
         ), (
             'When the database encoding is WIN874',
             dict(
-                db_encoding='WIN874',
+                db_encoding='cp874',
                 expected_return_value=['WIN874', 'cp874', 'cp874']
             )
         ),
@@ -224,4 +217,5 @@ class TestEncoding(BaseTestGenerator):
 
     def runTest(self):
         result = get_encoding(self.db_encoding)
+        print("result===", result)
         self.assertEqual(result, self.expected_return_value)
diff --git a/web/regression/python_test_utils/sql_template_test_base.py b/web/regression/python_test_utils/sql_template_test_base.py
index 6bb9d5a51..2a448c90e 100644
--- a/web/regression/python_test_utils/sql_template_test_base.py
+++ b/web/regression/python_test_utils/sql_template_test_base.py
@@ -31,7 +31,10 @@ class SQLTemplateTestBase(BaseTestGenerator):
         # To be implemented by child classes
         pass
 
-    def generate_sql(self, version):
+    def get_server_version(self, connection):
+        return connection.info.server_version
+
+    def generate_sql(self, connection):
         # To be implemented by child classes
         pass
 
@@ -50,7 +53,7 @@ class SQLTemplateTestBase(BaseTestGenerator):
             cursor = connection.cursor()
             self.test_setup(connection, cursor)
 
-            sql = self.generate_sql(connection.server_version)
+            sql = self.generate_sql(connection)
 
             cursor = connection.cursor()
             cursor.execute(sql)
